#!/bin/sh

title()
{
    echo
    echo "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
    echo
    echo "------------------ $*"
    echo
}

confdir="/config/rs/zwave"

find "$confdir/automation/storage" -name '*.json' |
while read i; do
    title "$i"
    cat "$i"
done

for i in "$confdir/zbw/userid" "$confdir/zbw/passwd"; do
    title "$i"
    cat "$i"
done

#-------------------------------------------------------------------------

plugin_install_dir=`dirname "$0"`/..
plugin_install_dir=`cd "$plugin_install_dir"; pwd`

. "$plugin_install_dir/bin/plugin_env.sh"

curl="$plugin_install_dir/bin/curl.875x"

zway_config_dir="$zway_data_dir/automation/storage/"
zway_det_data_url="http://127.0.0.1:8083/ZWave.zway/Data/0"

if [ ! -x "$curl" ]; then
    title "Curl tool ($curl) is not executable, do not load ZWave config!"
    exit 1
fi

title 'ZWave config (http://127.0.0.1:8083/ZWave.zway/Data/0)'
credentials=`$plugin_install_dir/bin/get_credentials.sh`
$curl -kL -s -u "$credentials" "$zway_det_data_url"
