<?php
///////////////////////////////////////////////////////////////////////////

class MainEntryHandler implements UserInputHandler
{
    const ID = 'MainEntryHandler';

    private /* ZwaveControllerPlugin */ $plugin;

    public function __construct(ZwaveControllerPlugin $plugin)
    {
        $this->plugin = $plugin;
        UserInputHandlerRegistry::get_instance()->register_handler($this);
    }

    public function get_handler_id()
    {
        return MainEntryHandler::ID;
    }

    ///////////////////////////////////////////////////////////////////////

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('--> Entry handler: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        return $this->plugin->on_app_enter($this, $plugin_cookies, $user_input->selected_media_url);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
